<?php

/* -----------------------------------------------------------------------------------------
  VamShop - http://vamshop.com
  -----------------------------------------------------------------------------------------
  Copyright (c) 2014 VamSoft Ltd.
  License - http://vamshop.com/license.html
  --------------------------------------------------------------------------------------- */

class AdminController extends ModuleOfdfermaAppController {

    public $helpers = array('Time', 'Admin');
    public $components = array('ContentBase');
    public $uses = array('ModuleOfdferma', 'Content');
    public $paginate = array(
        'limit'     => 20, 
        'order'     => array('created_at' => 'desc'),
    );
    
	
    // 
    public function admin_help() {
        
        App::import('Controller', 'ModuleOfdferma.Ofdferma');
        $ofdFermaController = new OfdfermaController();
        
        if (!empty($this->data)) {
            foreach ($this->data['settingsForm'] as $key => $value) {
                $currentConfig = $ofdFermaController->ModuleOfdfermaSetting->find('first', ['conditions' => ['code' => $key]]);
                $currentConfig['ModuleOfdfermaSetting']['value'] = $value;
                $ofdFermaController->ModuleOfdfermaSetting->save($currentConfig['ModuleOfdfermaSetting']);
            }

            $this->Session->setFlash(__d('module_ofdferma', 'data_updated'));
            
            $this->redirect('/module_ofdferma/admin/admin_help/');
        } 
        
        $this->set('current_crumb', __d('module_ofdferma', 'Ofdferma'));
        $this->set('title_for_layout', __d('module_ofdferma', 'Ofdferma'));
        
        $this->set('ofdfermaSettings', $ofdFermaController->getSettings());
    }

    // 
    public function admin_index() {
        $this->set('current_crumb', __d('module_ofdferma', 'CheckList'));
        $this->set('title_for_layout', __d('module_ofdferma', 'CheckList'));

		if (isset($_POST['reset'])){
			$this->redirect('/module_ofdferma/admin/admin_index/');
		}
		
        $conditions = array();
        if (isset($_POST['data']['Search']['type']) && $_POST['data']['Search']['type']){
            $conditions['type'] = $_POST['data']['Search']['type'];
        }
        if (isset($_POST['data']['Search']['order_id']) && $_POST['data']['Search']['order_id']){
            $conditions['order_id'] = $_POST['data']['Search']['order_id'];
        }
        
        if (isset($_POST['data']['Search']['dstart']) && $_POST['data']['Search']['dstart'] && isset($_POST['data']['Search']['dend']) && $_POST['data']['Search']['dend']){
            $conditions['and'] = array(
                'created_at >= ' => date('Y-m-d 00:00:00', strtotime("{$_POST['data']['Search']['dstart']['year']}-{$_POST['data']['Search']['dstart']['month']}-{$_POST['data']['Search']['dstart']['day']}")),
                'created_at <= ' => date('Y-m-d 23:59:59', strtotime("{$_POST['data']['Search']['dend']['year']}-{$_POST['data']['Search']['dend']['month']}-{$_POST['data']['Search']['dend']['day']}"))
            );
        }else
        if (isset($_POST['data']['Search']['dstart']) && $_POST['data']['Search']['dstart']){
            $conditions['created_at >= '] = date('Y-m-d 00:00:00', strtotime("{$_POST['data']['Search']['dstart']['year']}-{$_POST['data']['Search']['dstart']['month']}-{$_POST['data']['Search']['dstart']['day']}"));
        }else
        if (isset($_POST['data']['Search']['dend']) && $_POST['data']['Search']['dend']){
            $conditions['created_at <= '] = date('Y-m-d 23:59:59', strtotime("{$_POST['data']['Search']['dend']['year']}-{$_POST['data']['Search']['dend']['month']}-{$_POST['data']['Search']['dend']['day']}"));
        }
        
        if ($conditions){
            $this->paginate = array_merge($this->paginate, array('conditions' => $conditions));
        }
        
        //$data = $this->ModuleOfdferma->find('all');
        $data = $this->paginate('ModuleOfdferma');
        
        App::import('Controller', 'ModuleOfdferma.Ofdferma');
        $ofdFermaController = new OfdfermaController();
        
        $aData = array();
        foreach ($data AS $key => $value) {
            $row = $value['ModuleOfdferma'];

            $row['type_name'] = $ofdFermaController->json_fix_cyr($ofdFermaController->getTextType($row['type']));
            
            if ('CONFIRMED' == $row['status']){
                $row['id_link'] = $ofdFermaController->getCheckLink($row);
            }
            
            $aData[] = $row;
            
        }

       $this->set('ofdfermas', $aData);
    }    
    
    public function admin_update($id) {
        
        App::import('Controller', 'ModuleOfdferma.Ofdferma');
        $ofdFermaController = new OfdfermaController();
            
        $result = $ofdFermaController->check_update($id);
            
        $this->Session->setFlash(__d('module_ofdferma', 'Updated'), 'bootstrap_alert_success');
        $this->redirect('/module_ofdferma/admin/admin_index/');
    }

    public function admin_check() {
        
        $order_id = (int)isset($_POST['order_id']) ? $_POST['order_id'] : '';
        
        $type = '';
        if(isset($_POST['Income'])){
            $type = 'Income';
        }
        if(isset($_POST['IncomeReturn'])){
            $type = 'IncomeReturn';
        }
     
        $order_id = (int)isset($_POST['order_id']) ? $_POST['order_id'] : '';
        if ($order_id && $type){
            App::import('Controller', 'ModuleOfdferma.Ofdferma');
            $ofdFermaController = new OfdfermaController();
        
            $result = $ofdFermaController->Check($order_id, $type);
            
            if ($result['status']){
                $this->Session->setFlash($result['mess'], 'bootstrap_alert_success');
            }else{
                $this->Session->setFlash($result['mess'], 'bootstrap_alert_error');
            }
        }
        
        $this->redirect('/orders/admin_view/' . ($order_id ? $order_id : ''));
    }
}