<?php

/* -----------------------------------------------------------------------------------------
  VamShop - http://vamshop.com
  -----------------------------------------------------------------------------------------
  Copyright (c) 2014 VamSoft Ltd.
  License - http://vamshop.com/license.html
  --------------------------------------------------------------------------------------- */
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

class SetupController extends ModuleOfdfermaAppController {

    public $uses = array('Module', 'Content', 'Event');
    public $components = array('ModuleBase');

    public function upgrade() {
        $this->ModuleBase->upgrade();
        $this->Session->setFlash(__('Module Upgraded'));
        $this->redirect('/modules/admin/');
    }

    public function install() {
        $this->ModuleBase->check_if_installed('ofdferma');

        // Create the new module record		
        $new_module = array();
        $new_module['Module']['name'] = 'Ferma OFD.ru';
        $new_module['Module']['icon'] = 'cus-cart-put';
        $new_module['Module']['alias'] = 'ofdferma';
        $new_module['Module']['version'] = $this->ModuleBase->get_version();
        $new_module['Module']['nav_level'] = '5';
        
        $new_module['Module']['description'] = 'console.log("1111");';
        
        $this->Module->save($new_module);


        // Create the payment type discount table
        $install_query = array();

        $install_query[] = "
            DROP TABLE IF EXISTS module_ofdfermas;
            CREATE TABLE IF NOT EXISTS `module_ofdfermas` (
                `id` varchar(36) NOT NULL,
                `type` varchar(12) NOT NULL,
                `inn` varchar(20) NOT NULL,
                `status` varchar(50) NOT NULL,
                `status_message` varchar(50) NOT NULL,
                `order_id` int(11) NOT NULL,
                `total` decimal(8,2) NOT NULL,
                `FN` varchar(50) NOT NULL,
                `RNM` varchar(50) NOT NULL,
                `FDN` varchar(50) NOT NULL,
                `FPD` varchar(50) NOT NULL,
                `created_at` datetime NOT NULL,
                `updated_at` datetime NOT NULL,
                PRIMARY KEY (`id`)
            ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
        ";

        $install_query[] = "
            DROP TABLE IF EXISTS `module_ofdferma_settings`;
            CREATE TABLE IF NOT EXISTS `module_ofdferma_settings` (
                `id` INT(11) NOT NULL AUTO_INCREMENT,
                `code` VARCHAR(20) NOT NULL,
                `type` VARCHAR(20) NOT NULL,
                `value` TEXT,
                `position` int(11) NOT NULL DEFAULT '999',
                `show` tinyint(1) NOT NULL,
                PRIMARY KEY (`id`)
             );
            INSERT INTO `module_ofdferma_settings`
            (`code`, `type`, `value`, `position`, `show`)
            VALUES
            ('login', 'text', '', 1, 1),
            ('password', 'text', '', 2, 1),
            ('inn', 'text', '', 3, 1),
            ('osn', 'select', 'Common', 4, 1),
            ('nds', 'select', 'Vat0', 5, 1),
            ('collapse', 'checkbox', '', 6, 1),
            ('collapse_name', 'text', '', 7, 1),
            ('status', 'select', '', 8, 1),
            ('email', 'text', '', 9, 1),
            ('token', 'text', '', 0, 0),
            ('token_exp_date', 'text', '', 0, 0)
        ";
        
		//Если поле не существует
		if ( ! $this->Module->query('SHOW COLUMNS FROM `content_products` LIKE "ofdferma_nds"')){
			$this->Module->query('ALTER TABLE `content_products` ADD COLUMN `ofdferma_nds` VARCHAR(20) NOT NULL');
		}
		
        foreach ($install_query AS $query) {
            $this->Module->query($query);
        }

        $this -> clearCache();
        
        $this->Session->setFlash(__('Module Installed'));
        $this->redirect('/module_ofdferma/admin/admin_help/');
    }

    public function uninstall() {
        // Delete the module record
        $module = $this->Module->findByAlias('ofdferma');
        $this->Module->delete($module['Module']['id']);

        // Deletes the tables
        //$uninstall_query[] = "ALTER TABLE `content_products` DROP COLUMN `ofdferma_nds`;";
        $uninstall_query[] = "DROP TABLE IF EXISTS `module_ofdfermas`;";
        $uninstall_query[] = "DROP TABLE IF EXISTS `module_ofdferma_settings`;";

		//Если поле существует
		if ($this->Module->query('SHOW COLUMNS FROM `content_products` LIKE "ofdferma_nds"')){
			$this->Module->query('ALTER TABLE `content_products` DROP COLUMN `ofdferma_nds`');
		}
		
        foreach ($uninstall_query AS $query) {
            $this->Module->query($query);
        }

        $this -> clearCache();
        
        $this->Session->setFlash(__('Module Uninstalled'));
        $this->redirect('/modules/admin/');
    }
    
    function clearCache(){
        // clear Cache::write() items
        Cache::clear();
        
        //clear core cache
        $cachePaths = array('views', 'persistent', 'models', 'catalog');
        foreach ($cachePaths as $config) {
            clearCache(null, $config, '');
        }
    }

}

?>