<?php

/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

/*App::import('Model', 'Content');
$Content = new Content();*/

class ofdFermaApi{
    
    
    // 
    private function get_token(){
        
        if ( ! $this->check_settings()) {
            return $this->log_msg(' ,      : , ,   , ,  ');
        };
        
        if ($this->option['token'] && ($this->option['token_exp_date'] > (time() - 10))) {
            return $this->log_msg('', true);
        }
        
        $ofd_login      = $this->option['login'];
        $ofd_pass       = $this->option['password'];
        
        $ofd_auth_url   = self::AUTH_URL;

        $response = $this -> execute_request($ofd_auth_url, array(
            "Login"     => $ofd_login,
            "Password"  => $ofd_pass,
        ));
        
        if (isset($response['result'])){
            $result = $response['result'];
            
            // 
            $this->option['token'] = $result['Data']['AuthToken'];
            $this->option['token_exp_date'] = $result['Data']['ExpirationDateUtc'];
            
            $PHPShopOrm = new PHPShopOrm($GLOBALS['SysValue']['base']['ofdferma']['ofdferma_system']);
            $PHPShopOrm->update(array('token_new' => $this->option['token'], 'token_exp_date_new' => $this->option['token_exp_date']));
            
            return $this->log_msg('', true);
        }
        
        return $response;
    }
    
    private function execute_request($url, $data = null) {  
        
        $data = $data;
        
        $options = array(
            "ssl" => array(
                "verify_peer" => false,
                "verify_peer_name" => false,
            ),
            'http' => array(
                'timeout' => 10,
                'ignore_errors' => true,
                'content' => json_encode($data),
                'header' => "Content-type: application/json\r\n" .
                "Accept: application/json" . "\r\n",
                "Content-Length: " . strlen(json_encode($data)) . "\r\n",
                'method' => 'POST',
            )
        );
        
        $context = stream_context_create($options);
        set_error_handler(array($this, 'customErrorHandler'));

        try {
            $result = file_get_contents($url, false, $context);
        } catch (Exception $e) {
            return $this->log_msg($e->getMessage());
        }
        
        restore_error_handler();
        $result = json_decode($result, TRUE);
        
        if (isset($result['Status']) && ($result['Status'] == 'Success')) {
            return $this->log_msg('', true, array('result' => $result));
        } else if (isset($result['Status']) && ($result['Status'] == 'Failed')) {
            $msg = $result['Error']['Message'];
            if ($result['Error']['Code']) {
                if ($val = $this->getErrorByCode($result['Error']['Code'], $data)) {
                    $msg = $val;
                }
            }
            
            return $this->log_msg($msg, false, $result);
        } else {
            return $this->log_msg('some error', false, $result);
        }
    }
    
    /**
    *     Ferma
    * @param array $data  
    * @param string $operation  [sale|sale_refund]
    * @param bool $json      JSON 
    */
   function Check($data_order, $type = 'Income') {
        //PHPShopString::utf8_win1251
       
        $order_id = $data_order['uid'];
        $temptype = $this -> getTextType($type);
        
        //   
        $order = @unserialize($data_order['orders']);
        
        if ( ! $order['Cart']['cart']) {
            return $this->log_msg("  #{$order_id}  ");
        }
        
        if ($this -> get_receipt($data_order['id'], $type)){
            return $this->log_msg(" {$temptype}   {$order_id}    ");
        }
        
        $res = $this->get_token();
        if ( ! $res['status']) {
            return $res;
        }
        
        //   
        $prefix     = 't-phpshop-7';
        
        $ofd_osn    = $this->option['osn'];
        $ofd_inn    = $this->option['inn'];
        $ofd_nds    = $this->option['nds'];
        
        //
        $ofd_collapse       = $this->option['collapse'];
        $ofd_collapse_name  = $this->option['collapse_name'];
        
        $customer_phone = str_replace(array('(', ')', '-', ' '), '', $data_order['tel']);
        $customer_email = $order['Person']['mail'];     

        // 
        $data = array();
        $data['Request']['Inn'] = $ofd_inn;
        $data['Request']['Type'] = $type;
        $data['Request']['InvoiceId'] = $prefix . $order_id . '-' . $type;
        $data['Request']['LocalDate'] = date('Y-m-d\TH:i:s');
        $data['Request']['CustomerReceipt'] = array(
            'TaxationSystem'    => $ofd_osn,
            'Email'             => $customer_email,
            'Phone'             => $customer_phone,
            'Items'             => array(),
        );
           
        //
        if (is_array($order['Cart']['cart'])) {
            foreach ($order['Cart']['cart'] as $product){
                $vat = $this->get_product_vat($product['id'], $ofd_nds);
                
                array_push($data['Request']['CustomerReceipt']['Items'], array(
                        'Label'     => $product['name'],
                        'Price'     => $this->formatFloat( $product['price'] ),
                        'Quantity'  => $this->formatFloat( $product['num'], 3),
                        'Amount'    => $this->formatFloat( $product['price'] * $product['num'] ),
                        'Vat'       => $vat,
                    )
                );
            }
        }

        // 
        if (!empty($order['Cart']['dostavka'])) {
            array_push($data['Request']['CustomerReceipt']['Items'], array(
                    'Label'     => '',
                    'Price'     => $this->formatFloat( $order['Cart']['dostavka'] ),
                    'Quantity'  => $this->formatFloat( 1, 3),
                    'Amount'    => $this->formatFloat( $order['Cart']['dostavka'] ),
                    'Vat'       => $ofd_nds,
                )
            );
        }
        
        //  
        if ($ofd_collapse) {
            $pos_name = $ofd_collapse_name ? $ofd_collapse_name : 'Undefined';

            $sum = 0;
            foreach ($data['Request']['CustomerReceipt']['Items'] as $item) {
                $sum += $item['Amount'];
            }
            $data['Request']['CustomerReceipt']['Items'] = array(array(
                    'Label'     => $pos_name,
                    'Price'     => $sum,
                    'Quantity'  => 1,
                    'Amount'    => $sum,
                    'Vat'       => $ofd_nds,
            ));
        }
        
        
        //   
        $api_url = self::API_URL . "/receipt?AuthToken=" . $this->option['token'];
        $response = $this -> execute_request($api_url, $data);
        //die(var_dump($data));
        if (isset($response['result'])){
            $result = $response['result'];
            
            //  
            $PHPShopOrm = new PHPShopOrm($GLOBALS['SysValue']['base']['ofdferma']['ofdferma_log']);
            $PHPShopOrm->insert(array(
                'id_new'        => $result['Data']['ReceiptId'],
                'type_new'      => $data['Request']['Type'],
                'inn_new'       => $data['Request']['Inn'],
                'order_id_new'  => $data_order['id'],
                'order_uid_new' => $order_id,
                'total_new'     => $data_order['sum'],
                'created_at_new'=> gmdate('Y-m-d H:i:s')
            ));
                 
            return $this->log_msg(" {$temptype}   {$order_id} : {$result['Data']['ReceiptId']}", true);
        }else{
            return $response;
        }
    }
   
    //  
    public function check_update($id){
        
        $res = $this->get_token();
        if ( ! $res['status']) {
            return $res;
        }

        $PHPShopOrm = new PHPShopOrm($GLOBALS['SysValue']['base']['ofdferma']['ofdferma_log']);
        $results = $PHPShopOrm->select(array('*'), array('status' => " NOT IN ('FAILED')", 'id' => "='{$id}'"), false, array('limit' => 10));
        
        $this -> setDebug(1);
        foreach ($results as $result) {
            $data = array();
            $data['Request']['ReceiptId'] = $result['id'];
            
            //   
            $api_url = self::API_URL . "/status?AuthToken=" . $this->option['token'];
            $response = $this -> execute_request($api_url, $data);

            if (isset($response['result'])){
                $PHPShopOrm->clean();
                // 
                $PHPShopOrm->update(array(
                    'status_new'            => $response['result']['Data']['StatusName'],
                    'status_message_new'    => $response['result']['Data']['StatusMessage'],
                    'FN_new'                => $response['result']['Data']['Device']['FN'],
                    'RNM_new'               => $response['result']['Data']['Device']['RNM'],
                    'FDN_new'               => $response['result']['Data']['Device']['FDN'],
                    'FPD_new'               => $response['result']['Data']['Device']['FPD'],
                    'updated_at_new'        => gmdate('Y-m-d H:i:s')
                ), array('id' => "='{$result['id']}'"));
            }
        }
        $this -> setDebug(0);
    }
}